#include <graphics.h>	// line()
#include <conio.h>	// getch()
#include <stdio.h>	// printf()
#include <math.h>	// sin()

// wandelt Winkelangaben in Grad zu Bogenma um
#define Grad_zu_Rad(Winkel)	(Winkel*M_PI/180)

// rundet eine Gleitkommazahl (float) auf eine Ganzzahl (int), anstatt sie
// abzubrechen (der Borland C++ Run-Time-Library entnommen)
#define runde(Gleitkommazahl)	floor(Gleitkommazahl+0.5)

typedef struct
	{
	 float Winkel;	// in Bogenma
	 int Laenge;    // in Pixel
	} TVektor;	// ein Vektor in Polarform

typedef struct
	{
	 int x;		// in Pixel
	 int y;		// in Pixel
	 float Winkel;	// in Bogenma
	 int Laenge;    // in Pixel
	} TLinie;	// eine Linie, deren Startvektor in kartesischer Form
			// und deren Richtungsvektor in Polarform angegeben ist

// die erste Grundlinie
TLinie Grundlinie;

// die beiden kurzen Linien oberhalb der Grundlinie:
// Linie1 und Linie2 sind ihre Richtungsvektoren (relativ zur Grundlinie);
// Position_Linie1 und Position_Linie2 sind die Startvektoren dieser beiden
// Linien (ebenfalls relativ zum Startvektor der Grundlinie); sie sind in
// Polarform angegeben, damit sie spter leichter gedreht werden knnen
TVektor Linie1,Linie2,Position_Linie1,Position_Linie2;

int Rekursionstiefe=0;		// speichert die aktuelle Rekursionstiefe
int maximale_Rekursionstiefe;	// die vom Benutzer eingegebene maximale
				// Rekursionstiefe

void zeichne_Linie(TLinie Linie)
{
 // die Koordinaten des Endpunktes der zu zeichnenden Linie in kartesischer
 // Form und absolut (d.h. relativ zur linken oberen Ecke des Bildschirms)
 int Ende_x,Ende_y;

 Ende_x=Linie.x+runde(Linie.Laenge*cos(Linie.Winkel));
 Ende_y=Linie.y+runde(Linie.Laenge*sin(Linie.Winkel));

 line(Linie.x,Linie.y,Ende_x,Ende_y);
}

void zeichne_Fraktal(TLinie neue_Grundlinie)
{
 TLinie neue_Linie1,neue_Linie2;	// fr den nchsten rekursiven Aufruf
 float Skalierungsfaktor;

 // zeichne aktuelle Grundlinie
 zeichne_Linie(neue_Grundlinie);

 // Wenn die maximale Rekursionstiefe berschritten wird, dann nicht
 // weitermachen, sondern eine Ebene zurckspringen
 if(++Rekursionstiefe > maximale_Rekursionstiefe)
 {
  Rekursionstiefe--;
  return;
 }

 // alle Linien werden im selben Verhltnis verkleinert, wie die Grundlinie
 // verkleinert worden ist
 Skalierungsfaktor=(float)neue_Grundlinie.Laenge/Grundlinie.Laenge;

 // skaliere die Linienlngen
 neue_Linie1.Laenge=Skalierungsfaktor*Linie1.Laenge;
 neue_Linie2.Laenge=Skalierungsfaktor*Linie2.Laenge;

 // drehe Linien
 neue_Linie1.Winkel=neue_Grundlinie.Winkel+Linie1.Winkel;
 neue_Linie2.Winkel=neue_Grundlinie.Winkel+Linie2.Winkel;

 // berechne Anfangsposition der neuen Linien
 neue_Linie1.x=neue_Grundlinie.x+runde((Position_Linie1.Laenge
	*Skalierungsfaktor)*cos(neue_Grundlinie.Winkel+Position_Linie1.Winkel));
 neue_Linie1.y=neue_Grundlinie.y+runde((Position_Linie1.Laenge
	*Skalierungsfaktor)*sin(neue_Grundlinie.Winkel+Position_Linie1.Winkel));
 neue_Linie2.x=neue_Grundlinie.x+runde((Position_Linie2.Laenge
	*Skalierungsfaktor)*cos(neue_Grundlinie.Winkel+Position_Linie2.Winkel));
 neue_Linie2.y=neue_Grundlinie.y+runde((Position_Linie2.Laenge
	*Skalierungsfaktor)*sin(neue_Grundlinie.Winkel+Position_Linie2.Winkel));

 // gehe eine Rekursionsebene tiefer
 zeichne_Fraktal(neue_Linie1);
 zeichne_Fraktal(neue_Linie2);

 // O.K., alles erledigt, nun eine Ebene zurck und da weitermachen
 Rekursionstiefe--;
}

// Hauptprogramm
int main()
{
 // ich gehe vom VGA-Grafikmodus 640 mal 480 Pixel aus (Modus 12h)
 int Grafiktreiber=VGA,Grafikmodus=VGAHI;

 printf("Maximale Rekursionstiefe ? ");
 scanf("%d",&maximale_Rekursionstiefe);

 initgraph(&Grafiktreiber,&Grafikmodus,"");

 // falls es Grafikprobleme gibt
 if(graphresult()!=grOk)
 {
  printf("Fehler! Beende Programm! (BGI-Fehler %d)\n",graphresult);
  return 1;
 }

 Grundlinie.x=200;
 Grundlinie.y=400;
 Grundlinie.Winkel=Grad_zu_Rad(0);
 Grundlinie.Laenge=300;

 Position_Linie1.Winkel=Grad_zu_Rad(-160);
 Position_Linie1.Laenge=75;
 Linie1.Winkel=Grad_zu_Rad(-45);
 Linie1.Laenge=250;

 Position_Linie2.Winkel=Grad_zu_Rad(-20);
 Position_Linie2.Laenge=300;
 Linie2.Winkel=Grad_zu_Rad(-80);
 Linie2.Laenge=250;

 // Originalfigur ist bekannt => mach draus ein Fraktal !
 zeichne_Fraktal(Grundlinie);

 // warten, bis der User das Bild fertig angeschaut hat und eine Taste drckt
 getch();

 // Grafikmodus aus !
 closegraph();

 return 0;
}
