#include <stdio.h> 	// printf()
#include <conio.h>	// getch()
#include <limits.h>	// INT_MAX

#define MAX_WOLKEN	50
#define ABGEREGNET	INT_MAX

typedef struct
	{
	 int Zeile;
	 int Spalte;
	} TWolke;	// das ist eine Wolke (Position)

typedef struct
	{
	 int Zeile;
	 int Spalte;
	 int Anzahl;
	} TRegen;	// das ist ein Ort, an dem es regnet

int main()
{
 int Laenge=0;			// Seitenlnge von Quadratien
 int Anzahl_Wolken=0;		// Gesamtanzahl der vorhandenen Wolken
 int Anzahl_Wolken_West=0;	// Anzahl der Wolken aus Westen
 int Anzahl_Wolken_Nord=0;	// Anzahl der Wolken aus Norden
 int Anzahl_Regen=0;		// Anzahl der Orte, an denen es regnet
 TWolke Wolke_West[MAX_WOLKEN];// enthlt die Koordinaten der westlichen Wolken
 TWolke Wolke_Nord[MAX_WOLKEN];// enthlt die Koordinaten der nrdlichen Wolken
 TWolke Wolke_temporaer;	// zum Einlesen der Koordinaten

 // es kann hchstens halb so oft regnen, wie Wolken da sind
 TRegen Regen[MAX_WOLKEN/2];

 int i,j,k;			// Zhlvariablen
 char eingabe[10];		// Eingabestring

 // gibt an, ob sich mindestens eine nicht-abgeregnete Wolke im Land befindet
 int flag_aktive_Wolken;

 // Abfrage der Gre des Landes
 printf("Gib die Lnge einer Seite von Quadratien ein => ");
 scanf("%d",&Laenge);
 printf("\n");

 // Abfrage der Anzahl der Wolken
 printf("Gib die Anzahl der Wolken ein => ");
 scanf("%d",&Anzahl_Wolken);
 printf("\n");

 // Einlesen der Koordinaten der Wolken
 printf("Bitte gib jetzt die Koordinaten der Wolken ein,\nund zwar Zeile/Spalte"
	" (z.B. -3/5):\n");
 gets(eingabe);

 for(i=0;i<Anzahl_Wolken;i++)
 {
  printf("%d. Wolke: Koordinaten?  ",i+1);
  gets(eingabe);

  // bei einem Eingabefehler: Eingabe wiederholen lassen
  if(sscanf(eingabe,"%d/%d",&Wolke_temporaer.Zeile,&Wolke_temporaer.Spalte)!=2)
  {
   printf("Fehler! Nochmal:\n");
   i--;
   continue;
  }

  // Ist die Wolke nrdlich von Quadratien?
  if(Wolke_temporaer.Zeile<0)
  {
   // ja, diese Wolke kommt von Norden -> einsortieren
   Wolke_Nord[Anzahl_Wolken_Nord].Zeile=Wolke_temporaer.Zeile;
   Wolke_Nord[Anzahl_Wolken_Nord].Spalte=Wolke_temporaer.Spalte;
   Anzahl_Wolken_Nord++;	// 1 Wolke mehr aus nrdl. Richtung registriert
  }
  // Ist die Wolke nrdlich von Quadratien?
  else if(Wolke_temporaer.Spalte<0)
  {
   // ja, diese Wolke kommt aus Westen -> einsortieren
   Wolke_West[Anzahl_Wolken_West].Zeile=Wolke_temporaer.Zeile;
   Wolke_West[Anzahl_Wolken_West].Spalte=Wolke_temporaer.Spalte;
   Anzahl_Wolken_West++;	// 1 Wolke mehr aus westl. Richtung registriert
  }
 }

 printf("\n%d Wolken aus Norden und %d Wolken aus Westen\n",
	Anzahl_Wolken_Nord,Anzahl_Wolken_West);


 for(i=0;i<Anzahl_Wolken/2;i++) Regen[i].Anzahl=0;	// Werte auf 0 setzen

 do
 {
  flag_aktive_Wolken=0;		// noch gibt's keine aktive Wolken

  for(i=0;i<Anzahl_Wolken_Nord;i++)	// mit allen nrdlichen Wolken...
  {
   // ...um 2 nach Sden, falls sie noch nicht abgeregnet ist
   if(Wolke_Nord[i].Zeile!=ABGEREGNET) Wolke_Nord[i].Zeile+=2;

   // befindet sich die Wolke noch in Quadratien?
   // wenn ja, dann ist sie also noch 'aktiv'
   if(Wolke_Nord[i].Zeile<Laenge) flag_aktive_Wolken=1;
  }

  for(i=0;i<Anzahl_Wolken_West;i++)
  {
   // alle westl. Wolken um 3 nach Osten, falls sie noch nicht abgeregnet sind
   if(Wolke_West[i].Spalte!=ABGEREGNET) Wolke_West[i].Spalte+=3;

   // befindet sich die Wolke noch in Quadratien?
   // wenn ja, dann ist sie also noch 'aktiv'
   if(Wolke_West[i].Spalte<Laenge) flag_aktive_Wolken=1;
  }

  // Wo regnet es? Alle Kombinationen von westl./nrdl. Wolken untersuchen!
  for(i=0;i<Anzahl_Wolken_Nord;i++)
  {
   for(j=0;j<Anzahl_Wolken_West;j++)
   {

    // wenn zwei Wolken auf einem Quadrat sind und sich im Land befinden...
    // (eigentlich knnen sich keine Wolken westlich oder nrdlich von
    // Quadratien treffen - ich habe die berprfung aber der Vollstndigkeit
    // wegen aufgenommen; (Wolke_Nord[i].Spalte>=0) und
    // (Wolke_Nord[i].Zeile>=0) sind hier unntig, da der Benutzer keine Wolken
    // eingeben darf, die nordwestlich vo Quadratien sind)
    if((Wolke_Nord[i].Zeile==Wolke_West[j].Zeile)
	&&(Wolke_Nord[i].Spalte==Wolke_West[j].Spalte)
	&&(Wolke_Nord[i].Spalte<Laenge)&&(Wolke_Nord[i].Spalte>=0)
	&&(Wolke_Nord[i].Zeile<Laenge)&&(Wolke_Nord[i].Zeile>=0))
    {
     // alle Regenorte durchschauen, ob es an diesem Ort schon mal geregnet hat
     for(k=0;k<Anzahl_Regen;k++)
     {
      // wenn der Ort schon in der Regenliste vorhanden ist...
      if((Regen[k].Zeile==Wolke_Nord[i].Zeile)
	&&(Regen[k].Spalte==Wolke_Nord[i].Spalte))
      {
	Regen[k].Anzahl++;	// ...eintragen, dass es dort einmal mehr regnet
	break;			// fertig - vorzeitig raus aus der Suchschleife
      }
     }

     // die Suchschleife wurde komplett durchlaufen => Eintrag in der Regenliste
     // noch nicht vorhanden => neuen erzeugen
     if(k==Anzahl_Regen)
     {
      // Koordinaten des Quadrats in der Regenliste registrieren
      Regen[Anzahl_Regen].Zeile=Wolke_Nord[i].Zeile;
      Regen[Anzahl_Regen].Spalte=Wolke_Nord[i].Spalte;

      // ein Regenquadrat mehr, dort hat es einmal geregnet
      Regen[Anzahl_Regen].Anzahl=1;
      Anzahl_Regen++;
     }

     // beide Wolken als abgeregnet markieren (es reicht aus, nur jeweils
     // eine der Koordinaten zu markieren)
     Wolke_Nord[i].Zeile=ABGEREGNET;
     Wolke_West[j].Spalte=ABGEREGNET;
     continue;
    }
   }
  }

 // solange es aktive Wolken gibt, also Wolken im Land sind,
 // die nicht abgeregnet sind
 }while(flag_aktive_Wolken==1);

 // Ergebnis ausgeben
 for(i=0;i<Anzahl_Regen;i++) printf("Es regnet an %d/%d insgesamt %d mal.\n",
	Regen[i].Zeile,Regen[i].Spalte,Regen[i].Anzahl);

 printf("Fertig - jetzt herrscht eitel Sonnenschein in Quadratien!\nTaste..\n");

 getch();

 return 0;
}
