#include <stdio.h>			// printf()
#include <string.h>			// strcpy()
#include <conio.h>			// getch()

#define MAX_PERSONEN		100	// maximal 100 Leute kennen sich
#define MAX_BEKANNTE		20	// eine Person kennt maximal 20 andere
					// Personen
#define MAX_NAME		15	// maximale Lnge eines Namens + 1
					// in Buchstaben

struct TPerson
	{
	 char Name[MAX_NAME];
	 int von_Party_gehoert;
	 int Anzahl_Bekanntschaften;
	 TPerson *Bekannter[MAX_BEKANNTE];
	};

// Globale Variablen
TPerson Person[MAX_PERSONEN];	// die Gesamtheit aller beteiligten Personen
int Anzahl_Personen=0;		// Anzahl dieser Personen
TPerson *Robert=NULL;		// Pointer auf eine der Personen, die die
				// Funktion des "Robert" hat

TPerson *registriere_neue_Person(const char *Name)
{
 Anzahl_Personen++;			// eine Person mehr

 // in der Aufgabe ist ja ausdrcklich hingeschrieben, dass Katrin Kfer
 // niemandem etwas erzhlt
 if(strcmp(Name,"Katrin")==0)
 {
  printf("Achtung: Falls Katrin Kfer gemeint ist: die darf nicht eingegeben"
  	" werden,\nweil sie niemandem von der Party erzhlt\n");
 }

 // hinter den letzten belegten Eintrag im Array 'Person' die Daten der neuen
 // Person eintragen
 strcpy(Person[Anzahl_Personen-1].Name,Name);
 Person[Anzahl_Personen-1].von_Party_gehoert=0;
 // neue Person - noch keine Bekanntschaften eingetragen
 Person[Anzahl_Personen-1].Anzahl_Bekanntschaften=0;

 // Pointer auf den neuen Record zurckgeben
 return &Person[Anzahl_Personen-1];
}

void registriere_Bekanntschaft(const char *Name1,const char *Name2)
{
 TPerson *Person_mit_Name1=NULL,*Person_mit_Name2=NULL;
 int i;	// Schleifenzhlvariable

 // durchsuchen, ob die beiden Namen schon bekannt sind
 for(i=0;i<Anzahl_Personen;i++)
 {
  if(strcmp(Name1,Person[i].Name)==0) Person_mit_Name1=&Person[i];
  if(strcmp(Name2,Person[i].Name)==0) Person_mit_Name2=&Person[i];
 }

 // falls Person mit dem eingegebenen Namen 'Name1' noch nicht registriert ist
 if(Person_mit_Name1==NULL) Person_mit_Name1=registriere_neue_Person(Name1);

 // falls Person mit dem eingegebenen Namen 'Name2' noch nicht registriert ist
 if(Person_mit_Name2==NULL) Person_mit_Name2=registriere_neue_Person(Name2);

 // Jetzt die Bekanntschaft registrieren (in beide Richtungen)
 Person_mit_Name1->Bekannter[Person_mit_Name1->Anzahl_Bekanntschaften++]=
	Person_mit_Name2;
 Person_mit_Name2->Bekannter[Person_mit_Name2->Anzahl_Bekanntschaften++]=
	Person_mit_Name1;
}

void weitersagen(TPerson *p)
{
 int i;				// Schleifenzhlvariable

 // wenn dieser Bekannte schon von der Party gehrt hat, ist es unsinnig,
 // ihm davon zu erzhlen; er wei es ja schon und hat es schon allen seinen
 // Freunden gesagt
 if(p->von_Party_gehoert==1) return;

 // er wusste noch nichts von der Party, aber jetzt wei er es!
 p->von_Party_gehoert=1;

 // jetzt sagt er es allen weiter (rekursiver Aufruf der Funktion)
 for(i=0;i<p->Anzahl_Bekanntschaften;i++)
 {
  weitersagen(p->Bekannter[i]);
 }
}

void gib_Ergebnis_aus()
{
 int Party_Meldungen=0;	// gibt an, wie oft Robert von der Party hrt
 int i;			// Schleifenzhlvariable

 printf("\n%s hrt von...\n",Robert->Name);

 // bei allen seinen Bekannten wird die Variable 'von_Party_gehoert' abgefragt;
 // jedesmal, wenn sie auf 1 steht, hat dieser Bekannter von Katrins Party
 // gehrt und wird es Robert erzhlen, also wird 'Party_Meldungen' um 1 erhht
 for(i=0;i<Robert->Anzahl_Bekanntschaften;i++)
 {
  if((Robert->Bekannter[i])->von_Party_gehoert==1)
  {
   printf("%s, ",Robert->Bekannter[i]->Name);
   Party_Meldungen++;
  }
 }

 printf("\nalso von %d Personen, wie toll Katrins Party war!\n",
	Party_Meldungen);
}

// zeige alle Bekanntschaftverhltnisse nochmal an, damit der arme Benutzer,
// der alle Namen einzeln eingeben musste, berprfen kann, ob alles stimmt
void zeige_Freundeskreis()
{
 int i,j;
 char Klammer1,Klammer2;

 printf("\nZusammenfassung der Bekanntschaften\n(Klammern um einen Namen"
	 " bedeuten, dass die entspr. Person nichts von der Party wei):\n");

 for(i=0;i<Anzahl_Personen;i++)
 {
  printf("%s kennt ",Person[i].Name);

  for(j=0;j<Person[i].Anzahl_Bekanntschaften;j++)
  {

   if(Person[i].Bekannter[j]->von_Party_gehoert==1)
   {
    Klammer1=' ';
    Klammer2=' ';
   }
   else
   {
    Klammer1='(';
    Klammer2=')';
   }

   // auf einen ordentlichen Zeilenumbruch verzichte ich hier...
   printf("%c%s%c, ",Klammer1,Person[i].Bekannter[j]->Name,Klammer2);
  }

  printf("\n");
 }
}

// Hauptprogramm
int main()
{
 char Name1[MAX_NAME],Name2[MAX_NAME],Eingabe[MAX_BEKANNTE*MAX_NAME];
 char *String_Pointer;
 int i;			// Schleifenzhlvariable

 printf("Eingabe der Partygste: Gib alle Namen ein (maximal %d Buchstaben)"
	";\nnach dem letzten Gast einfach nochmal die Eingabetaste drcken.\n"
	"Es muss mindestens *ein* Gast angegeben werden!!!\n\n",
	MAX_NAME-1);

 while(1)
 {

  printf("%d. Gast: ",Anzahl_Personen+1);
  gets(Name1);
  if(strcmp(Name1,"")==0) break;	// das war die letzte Eingabe

  registriere_neue_Person(Name1);

  // Bekanntschaft mit allen anderen Gsten registrieren
  for(i=0;i<Anzahl_Personen-1;i++)
  {
   registriere_Bekanntschaft(Name1,Person[i].Name);
  }

 }

 printf("\nWie heit der Abwesende, der von der Party hren soll? ");
 gets(Name1);
 Robert=registriere_neue_Person(Name1);
 Robert->von_Party_gehoert=1;	// damit bei ihm die Rekursion stoppt

 printf("\nJetzt die Eingabe der Bekanntschaften:\n");

 while(1)
 {

  printf("\nPerson 1: ");
  gets(Name1);
  // War das die letzte Eingabe ?
  if(strcmp(Name1,"")==0) break;

  printf("kennt: ");
  gets(Eingabe);
  // War das die letzte Eingabe ?
  if(strcmp(Eingabe,"")==0) break;

  // nach dem ersten Textstck suchen, das mit ein/mehreren Leerzeichen aufhrt
  String_Pointer=strtok(Eingabe," ");

  // solange Textstcke gefunden werden
  while(String_Pointer!=NULL)
  {
   // ja - einen Namen gefunden => Gefundenes in die Variable Name2 kopieren
   strcpy(Name2,String_Pointer);

   // die Bekanntschaft sofort registrieren
   registriere_Bekanntschaft(Name1,Name2);

   // nach weiteren Namen suchen
   String_Pointer=strtok(NULL," ");	// sucht nach Leerzeichen
  }
 }

 // hier luft die Rekursion ab, hier wird ermittelt, wer alles von der Party
 // erfhrt (da ja mindestens ein Partygast vorhanden sein muss, damit es Sinn
 // macht, wird hier angenommen, dass dies so ist, also Person[0] der erste Gast
 // ist)
 for(i=0;i<Person[0].Anzahl_Bekanntschaften;i++) weitersagen(&Person[0]);

 // zeig mal kurz das Ergebnis der Rekursion...
 zeige_Freundeskreis();

 // ...und gib dann die Lsung aus
 gib_Ergebnis_aus();

 printf("Taste...\n");
 getch();

 return 0;
}
